<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<itemFormativoEsercizio nomeDescrittivo="Regolazione di precisione" identificatoreArgomento="EncoderRotativoSemplice" prerequisiti="digitalInput,pwm" tags="Medio,DigitalInput,PWM,Software,Verificare implementazione" fondamentale="false" mdPblproblem="false" mdPblnewlearninggoal="false" tempoRichiesto="0" versione="2">
    <mdprerequisitelist>I/O digitale</mdprerequisitelist>
    <mdprerequisitelist>Gestione dei rimbalzi</mdprerequisitelist>
    <mdcomponentlist>Encoder rotativo</mdcomponentlist>
    <mdcomponentlist>Potenziometro</mdcomponentlist>
    <mdcomponentlist>Buzzer passivo</mdcomponentlist>
    <mdcomponentlist>Pulsante, nel caso non sia integrato nell'encoder</mdcomponentlist>
    <mdwhy>Input dal mondo fisico, consentendo all'utente di compiere una regolazione con un encoder rotativo con precisione maggiore di quella che si otterrebbe usando un potenziometro.</mdwhy>
    <mdexpectedresult>Definire un intervallo minimo e massimo di frequenze da utilizzare.&#13;
&#13;
Generare un segnale acustico partendo da una frequenza intermedia nell'intervallo scelto, e consentire all'utente di incrementarla ruotando l'encoder in senso orario e decrementarla ruotandolo in senso antiorario.&#13;
&#13;
Consentire all'utente, premendo il pulsante dell'encoder, di scegliere tra 3 possibili variazioni di frequenza per scatto: 1 Hz,10 Hz,100 Hz&#13;
La pressione del pulsante permette di iterare tra le opzioni, notificando all'utente la scelta fatta con l'emissione di un numero di bip corrispondente al numero dell'opzione, 1 Hz = 1 bip, 10 Hz = 2 bip, 100 Hz = 3 bip.&#13;
&#13;
Notificare le modifiche ai parametri inviando messaggi sulla porta seriale, in modo da consentire all'utente di comprendere come sta cambiando la variabile con il monitor seriale.</mdexpectedresult>
    <mdextras>Ripetere l'esercizio utilizzando un potenziometro, mappando l'intero intervallo di frequenze sui valori misurabili dall'input analogico, con la frequenza minima abbinata alla completa rotazione a sinistra, e quella massima alla completa rotazione a destra.&#13;
&#13;
(Alternativa al buzzer passivo) Pur non disponendo di hardware specifico, si può utilizzare come alternativa al buzzer passivo un altoparlante con in serie un resistore, ad esempio un altoparlante da 8 ohm 0.5w e un resistore da 220 Ohm, non meno, per limitare la corrente.</mdextras>
    <mderraticbehavior></mderraticbehavior>
    <mdcommonerrors>Possibile rilevamento della rotazione al contrario, se l'interfaccia dell'encoder permette di invertire la connessione.</mdcommonerrors>
    <mdlessonlearned>Utilizzare un encoder rotativo per consentire all'utente di regolare con precisione un parametro.</mdlessonlearned>
    <mdsolution>Collegare l'encoder rotativo secondo le indicazioni sul datasheet.&#13;
&#13;
Nel caso si abbia un encoder senza pulsante, collegare un pulsante tra massa e un pin GPIO, impostando quel GPIO in modalità INPUT_PULLUP.&#13;
&#13;
Collegare il polo positivo del buzzer passivo a un GPIO in modalità OUTPUT e il negativo a massa, se il buzzer ha un consumo &gt; di 20mA, servirà un resistore tra il GPIO e il positivo del buzzer, oppure si dovrà utilizzare un transistor BJT come driver.&#13;
In caso di modulo buzzer seguire le indicazioni sul modulo.</mdsolution>
    <mdpbldetails></mdpbldetails>
</itemFormativoEsercizio>
